Index: build-system/Makefile.binary
===================================================================
--- build-system/Makefile.binary	(revision 5775)
+++ build-system/Makefile.binary	(revision 5775)
@@ -0,0 +1,25 @@
+#
+# This file is part of roard a part of RoarAudio,
+# a cross-platform sound system for both, home and professional use.
+# See README for details.
+#
+# This file is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License version 3
+# as published by the Free Software Foundation.
+#
+# RoarAudio is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this software; see the file COPYING.  If not, write to
+# the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+# Boston, MA 02110-1301, USA.
+
+TARGET      ?= $(BASENAME)
+
+RABS_INSTALL_TARGETS += bin
+
+include $(ROAR_BUILDSYSTEM_DIR)/Makefile.common
+include $(ROAR_BUILDSYSTEM_DIR)/Makefile.install
Index: build-system/Makefile.common
===================================================================
--- build-system/Makefile.common	(revision 5775)
+++ build-system/Makefile.common	(revision 5775)
@@ -0,0 +1,46 @@
+#     Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2012
+#
+# This file is part of roard a part of RoarAudio,
+# a cross-platform sound system for both, home and professional use.
+# See README for details.
+#
+# This file is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License version 3
+# as published by the Free Software Foundation.
+#
+# RoarAudio is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this software; see the file COPYING.  If not, write to
+# the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+# Boston, MA 02110-1301, USA.
+
+OBJS        ?= $(BASENAME).o
+
+TARGETS     ?= $(TARGET)
+TARGET      ?= DUMMY
+
+OPTI_O      ?= -O2
+DEFINES     += -DBASENAME="\"$(BASENAME)\"" -DROAR_DBG_PREFIX="\"$(TARGET)\""
+CFLAGS      += -Wall $(Wextra) -g $(OPTI_O) $(DEFINES) $(INCLUDE) $(INCPATH) $(ROAR_CFLAGS)
+LDFLAGS     += -Wall $(Wextra) -g $(OPTI_O) $(LDPATH)
+LIBS        += $(lib_roar)
+
+all: $(TARGETS)
+clean:
+	rm -f $(TARGETS) *.o
+new: clean all
+
+distclean: clean
+	rm -f Makefile.conf config.h config.log
+
+$(TARGET): $(OBJS)
+	$(CC) $(LDFLAGS) -o $(TARGET) $(OBJS) $(LIBS)
+
+#define at least some as phony
+.PHONY: all clean new distclean prep-install-dirs prep-install install semi-install uninstall
+
+#ll
Index: build-system/Makefile.install
===================================================================
--- build-system/Makefile.install	(revision 5775)
+++ build-system/Makefile.install	(revision 5775)
@@ -0,0 +1,46 @@
+#     Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2012
+#
+# This file is part of roard a part of RoarAudio,
+# a cross-platform sound system for both, home and professional use.
+# See README for details.
+#
+# This file is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License version 3
+# as published by the Free Software Foundation.
+#
+# RoarAudio is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this software; see the file COPYING.  If not, write to
+# the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+# Boston, MA 02110-1301, USA.
+
+RABS_INSTALL_TARGETS_PREP_DIRS    := $(foreach c,$(RABS_INSTALL_TARGETS),prep-install-dirs-$c)
+RABS_INSTALL_TARGETS_INSTALL      := $(foreach c,$(RABS_INSTALL_TARGETS),install-$c)
+RABS_INSTALL_TARGETS_SEMI_INSTALL := $(foreach c,$(RABS_INSTALL_TARGETS),semi-install-$c)
+RABS_INSTALL_TARGETS_UNINSTALL    := $(foreach c,$(RABS_INSTALL_TARGETS),uninstall-$c)
+
+prep-install-dirs: $(RABS_INSTALL_TARGETS_PREP_DIRS)
+prep-install: all prep-install-dirs
+install: $(RABS_INSTALL_TARGETS_INSTALL)
+semi-install: $(RABS_INSTALL_TARGETS_SEMI_INSTALL)
+uninstall: $(RABS_INSTALL_TARGETS_UNINSTALL)
+
+prep-install-dirs-bin:
+	mkdir -p '$(DESTDIR)$(PREFIX_BIN)'
+	mkdir -p '$(DESTDIR)$(PREFIX_MAN)'/man1/
+
+prep-install-bin: all prep-install-dirs-bin
+
+install-bin: prep-install-bin
+	cp $(cp_v) $(TARGET)  '$(DESTDIR)$(PREFIX_BIN)'
+	cp $(cp_v) $(MANPAGE_1) '$(DESTDIR)$(PREFIX_MAN)'/man1/
+semi-install-bin: prep-install-bin
+	ln -fs `pwd`/$(TARGET)  '$(DESTDIR)$(PREFIX_BIN)'
+	ln -fs `pwd`/$(MANPAGE_1) '$(DESTDIR)$(PREFIX_MAN)'/man1/
+uninstall-bin:
+	rm -f '$(DESTDIR)$(PREFIX_BIN)/$(TARGET)'
+	rm -f '$(DESTDIR)$(PREFIX_MAN)/man1/$(MANPAGE_1)'
Index: build-system/Makefile.plugin
===================================================================
--- build-system/Makefile.plugin	(revision 5772)
+++ build-system/Makefile.plugin	(revision 5775)
@@ -19,20 +19,11 @@
 # Boston, MA 02110-1301, USA.
 
-TARGET      ?= $(BASENAME).so
-OBJS        ?= $(BASENAME).o
+TARGET      ?= $(BASENAME)$(SHARED_SUFFIX)
 
 ROAR_CFLAGS := $(shell roar-config --cflags)
 ROAR_LIBS   := $(shell roar-config --libs)
-OPTI_O      ?= -O2
-DEFINES     += -DBASENAME="\"$(BASENAME)\"" -DROAR_DBG_PREFIX="\"$(TARGET)\""
-CFLAGS      += -Wall $(Wextra) -g $(OPTI_O) $(fPIC) $(DEFINES) $(INCLUDE) $(INCPATH) $(ROAR_CFLAGS)
-LDFLAGS     += -Wall $(Wextra) -g $(OPTI_O) $(SHARED) $(LDPATH)
+CFLAGS      += $(fPIC)
+LDFLAGS     += $(SHARED)
 LIBS        += $(ROAR_LIBS)
 
-all: $(TARGET)
-clean:
-	rm -f $(TARGET) *.o
-new: clean all
-
-$(TARGET): $(OBJS)
-	$(CC) $(LDFLAGS) -o $(TARGET) $(OBJS) $(LIBS)
+include $(ROAR_BUILDSYSTEM_DIR)/Makefile.common