Index: roard/include/auth.h
===================================================================
--- roard/include/auth.h	(revision 5381)
+++ roard/include/auth.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/beep.h
===================================================================
--- roard/include/beep.h	(revision 5381)
+++ roard/include/beep.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/caps.h
===================================================================
--- roard/include/caps.h	(revision 5381)
+++ roard/include/caps.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/client.h
===================================================================
--- roard/include/client.h	(revision 5640)
+++ roard/include/client.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/codecfilter.h
===================================================================
--- roard/include/codecfilter.h	(revision 5381)
+++ roard/include/codecfilter.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/codecfilter_au.h
===================================================================
--- roard/include/codecfilter_au.h	(revision 5381)
+++ roard/include/codecfilter_au.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/codecfilter_celt.h
===================================================================
--- roard/include/codecfilter_celt.h	(revision 5381)
+++ roard/include/codecfilter_celt.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/codecfilter_cmd.h
===================================================================
--- roard/include/codecfilter_cmd.h	(revision 5381)
+++ roard/include/codecfilter_cmd.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/codecfilter_fishsound.h
===================================================================
--- roard/include/codecfilter_fishsound.h	(revision 5381)
+++ roard/include/codecfilter_fishsound.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/codecfilter_flac.h
===================================================================
--- roard/include/codecfilter_flac.h	(revision 5381)
+++ roard/include/codecfilter_flac.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/codecfilter_sndfile.h
===================================================================
--- roard/include/codecfilter_sndfile.h	(revision 5381)
+++ roard/include/codecfilter_sndfile.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/codecfilter_speex.h
===================================================================
--- roard/include/codecfilter_speex.h	(revision 5381)
+++ roard/include/codecfilter_speex.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/codecfilter_vorbis.h
===================================================================
--- roard/include/codecfilter_vorbis.h	(revision 5381)
+++ roard/include/codecfilter_vorbis.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/codecfilter_wave.h
===================================================================
--- roard/include/codecfilter_wave.h	(revision 5381)
+++ roard/include/codecfilter_wave.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/commands.h
===================================================================
--- roard/include/commands.h	(revision 5608)
+++ roard/include/commands.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/container_framework.h
===================================================================
--- roard/include/container_framework.h	(revision 5381)
+++ roard/include/container_framework.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver.h
===================================================================
--- roard/include/driver.h	(revision 5381)
+++ roard/include/driver.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_alsa.h
===================================================================
--- roard/include/driver_alsa.h	(revision 5381)
+++ roard/include/driver_alsa.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *      Copyright (C) Hans-Kristian 'maister' Arntzen - 2010
  *
Index: roard/include/driver_ao.h
===================================================================
--- roard/include/driver_ao.h	(revision 5381)
+++ roard/include/driver_ao.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_artsc.h
===================================================================
--- roard/include/driver_artsc.h	(revision 5381)
+++ roard/include/driver_artsc.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2011-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2011-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_dmx.h
===================================================================
--- roard/include/driver_dmx.h	(revision 5381)
+++ roard/include/driver_dmx.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_dstr.h
===================================================================
--- roard/include/driver_dstr.h	(revision 5381)
+++ roard/include/driver_dstr.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_esd.h
===================================================================
--- roard/include/driver_esd.h	(revision 5381)
+++ roard/include/driver_esd.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_jack.h
===================================================================
--- roard/include/driver_jack.h	(revision 5381)
+++ roard/include/driver_jack.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_oss.h
===================================================================
--- roard/include/driver_oss.h	(revision 5381)
+++ roard/include/driver_oss.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_portaudio.h
===================================================================
--- roard/include/driver_portaudio.h	(revision 5381)
+++ roard/include/driver_portaudio.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_pulsesimple.h
===================================================================
--- roard/include/driver_pulsesimple.h	(revision 5381)
+++ roard/include/driver_pulsesimple.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_pwmled.h
===================================================================
--- roard/include/driver_pwmled.h	(revision 5381)
+++ roard/include/driver_pwmled.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_raw.h
===================================================================
--- roard/include/driver_raw.h	(revision 5381)
+++ roard/include/driver_raw.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_roar.h
===================================================================
--- roard/include/driver_roar.h	(revision 5381)
+++ roard/include/driver_roar.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_rsound.h
===================================================================
--- roard/include/driver_rsound.h	(revision 5381)
+++ roard/include/driver_rsound.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_shout.h
===================================================================
--- roard/include/driver_shout.h	(revision 5381)
+++ roard/include/driver_shout.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_sndio.h
===================================================================
--- roard/include/driver_sndio.h	(revision 5381)
+++ roard/include/driver_sndio.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_sysclock.h
===================================================================
--- roard/include/driver_sysclock.h	(revision 5381)
+++ roard/include/driver_sysclock.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/driver_wmm.h
===================================================================
--- roard/include/driver_wmm.h	(revision 5381)
+++ roard/include/driver_wmm.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/empty.h
===================================================================
--- roard/include/empty.h	(revision 5381)
+++ roard/include/empty.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/emul_rsound.h
===================================================================
--- roard/include/emul_rsound.h	(revision 5381)
+++ roard/include/emul_rsound.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/emul_simple.h
===================================================================
--- roard/include/emul_simple.h	(revision 5381)
+++ roard/include/emul_simple.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/hwmixer.h
===================================================================
--- roard/include/hwmixer.h	(revision 5381)
+++ roard/include/hwmixer.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/lib.h
===================================================================
--- roard/include/lib.h	(revision 5568)
+++ roard/include/lib.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/light.h
===================================================================
--- roard/include/light.h	(revision 5706)
+++ roard/include/light.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/memlock.h
===================================================================
--- roard/include/memlock.h	(revision 5663)
+++ roard/include/memlock.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/meta.h
===================================================================
--- roard/include/meta.h	(revision 5381)
+++ roard/include/meta.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/midi.h
===================================================================
--- roard/include/midi.h	(revision 5381)
+++ roard/include/midi.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/mixer.h
===================================================================
--- roard/include/mixer.h	(revision 5381)
+++ roard/include/mixer.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/network.h
===================================================================
--- roard/include/network.h	(revision 5381)
+++ roard/include/network.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/output.h
===================================================================
--- roard/include/output.h	(revision 5381)
+++ roard/include/output.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/plugins.h
===================================================================
--- roard/include/plugins.h	(revision 5706)
+++ roard/include/plugins.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/raw.h
===================================================================
--- roard/include/raw.h	(revision 5381)
+++ roard/include/raw.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/rdtcs.h
===================================================================
--- roard/include/rdtcs.h	(revision 5381)
+++ roard/include/rdtcs.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/req.h
===================================================================
--- roard/include/req.h	(revision 5608)
+++ roard/include/req.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/roard.h
===================================================================
--- roard/include/roard.h	(revision 5754)
+++ roard/include/roard.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/rolestack.h
===================================================================
--- roard/include/rolestack.h	(revision 5381)
+++ roard/include/rolestack.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/sample.h
===================================================================
--- roard/include/sample.h	(revision 5381)
+++ roard/include/sample.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/sources.h
===================================================================
--- roard/include/sources.h	(revision 5586)
+++ roard/include/sources.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/ssynth.h
===================================================================
--- roard/include/ssynth.h	(revision 5381)
+++ roard/include/ssynth.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/streams.h
===================================================================
--- roard/include/streams.h	(revision 5740)
+++ roard/include/streams.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2013
  *
  *  This file is part of roard a part of RoarAudio,
Index: roard/include/waveform.h
===================================================================
--- roard/include/waveform.h	(revision 5381)
+++ roard/include/waveform.h	(revision 5823)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2012
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2013
  *
  *  This file is part of roard a part of RoarAudio,